<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Modelos</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>Gestionar Modelos</strong>
      </div>
      <div class="supSec">Gestiona los Modelos o Crea uno Nuevo</div>
    </div>
    <div class="pl-10 pr-10 contSecc lighten-5">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row>
          <v-col
            v-for="(modelo, indexModelo) in modelos"
            :key="indexModelo"
            :xs="12"
            :sm="12"
            :md="6"
            :lg="3"
          >
            <v-card class="generalCard pa-4">
              <div>
                <v-btn x-small class="float-left" text icon>
                  <v-img
                    @click="
                      showDialogDelete = true;
                      modeloToRemove = modelo;
                    "
                    :contain="true"
                    :aspect-ratio="1"
                    position="center"
                    src="@/assets/img/delete.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
                <v-btn :to="modelo.to" x-small class="float-right" text icon>
                  <v-img
                    :contain="true"
                    :aspect-ratio="1"
                    position="center"
                    src="@/assets/img/icoEditar.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
              </div>
              <v-card-text>
                <div class="cardFranqName cardFranqNameLine">
                  {{ modelo.nombre_modelo }}
                </div>
                <div class="cardCreacion">
                  <div>
                    Fecha de creación:
                    {{ moment(modelo.fecha_creacion).format("DD / MM / YYYY") }}
                  </div>
                  <div>
                    Creado por:
                    {{
                      serviceCommons.titleCase(
                        modelo.empleado_crea.nombre_usuario
                      )
                    }}
                  </div>
                </div>
                <div class="cardModificacion" v-if="modelo.empleado_modifica">
                  <div>
                    <b>
                      Fecha de última modificación:
                      {{
                        moment(modelo.fecha_modificacion).format(
                          "DD / MM / YYYY"
                        )
                      }}
                    </b>
                  </div>
                  <div>
                    <b>
                      Modificado por:
                      {{
                        serviceCommons.titleCase(
                          modelo.empleado_modifica.nombre_usuario
                        )
                      }}
                    </b>
                  </div>
                </div>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
      <v-row>
        <v-col :key="cardAdd.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAdd.to"
            :color="cardAdd.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAdd.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAdd.src"
                :lazy-src="cardAdd.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
    </div>
    <template>
      <v-dialog v-model="showDialogDelete" max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas eliminar este modelo?</strong>
              <v-btn
                color="secondary"
                icon
                dark
                @click="showDialogDelete = false"
                style="position: absolute;right: 0px;top: 0px;"
              >
                <v-icon>mdi-close</v-icon>
              </v-btn>
            </div>
          </v-card-title>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="showDialogDelete = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="removeModelo()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogDeleteConfirmacion" persistent max-width="700px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas eliminar este modelo?</strong>
            </div>
            <div class="pa-4">
              El modelo
              <strong>{{
                modeloToRemove ? modeloToRemove.nombre_modelo : ""
              }}</strong>
              tiene los siguientes ejes asignados:
              <br />

              <v-chip
                v-for="(eje, indexEje) in modeloToRemove.ejes_modelo"
                :key="indexEje"
                class="ma-2"
                >{{ getEjeFromMetadata(eje.id_eje).descripcion }}</v-chip
              >
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogDeleteConfirmacion = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteModelo"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<script>
import axios from "axios";
import moment from "moment";
import store from "@/store";
import { format } from "path";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-ModelosFranquicia",
  data() {
    return {
      moment: moment,
      showDialogDelete: false,
      dialogDeleteConfirmacion: false,
      cardAdd: {
        title: "Crear Modelo",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade un nuevo modelo.",
        to: {
          name: "modelo_franquicia_franquicias_franquicia_modelo_nuevo"
        },
        color: "#494949"
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Franquicias",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_franquicias"
          }
        }
      ],
      franquicia: {
        id_franquicia: null,
        descripcion: null,
        id_status: null,
        fecha_creacion: null,
        id_empleado_crea: null,
        fecha_modificacion: null,
        id_empleado_modifica: null,
        negocios_franquicia: null
      },
      metadata: {},
      modeloToRemove: {},
      modelos: []
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    initValues() {
      if (this.franquicia) {
        this.breadcrumbs.push({
          text: serviceCommons.titleCase(this.franquicia.descripcion),
          disabled: true
        });
      }
    },
    getEjeFromMetadata(id_eje) {
      if (this.metadata.ejes) {
        let ejes_filtered = this.metadata.ejes.filter(
          (itemEje) => itemEje.id_eje === id_eje
        )[0];
        return ejes_filtered;
      }
    },
    getModelos() {
      var self = this;
      axios
        .get(
          "/modelos/franquicia/secure/get/" +
            self.franquicia.id_franquicia +
            "/data"
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setModelos(data.modelos_franquicia);
              self.setMetadata(data.metadata);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setMetadata(data) {
      this.metadata = data;
    },
    setModelos(data) {
      if (data) {
        data.forEach((itemModelo) => {
          itemModelo.to = {
            name: "modelo_franquicia_franquicias_franquicia_modelo_edicion",
            params: {
              modelo: this.serviceCommons.objectToBase64(itemModelo)
            }
          };
        });
        this.modelos = data;
      }
    },
    deleteModelo() {
      var self = this;
      this.modeloToRemove.id_empleado_modifica = user.empleado;
      axios
        .delete("/modelos/franquicia/secure/delete/", {
          data: self.modeloToRemove
        })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.deleted) {
                self.modelos = self.modelos.filter(
                  (modelo) => modelo.id_modelo !== self.modeloToRemove.id_modelo
                );
                this.showDialogDelete = false;
                this.dialogDeleteConfirmacion = false;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    removeModelo() {
      if (this.modeloToRemove.ejes_modelo.length > 0) {
        this.dialogDeleteConfirmacion = true;
        this.showDialogDelete = false;
      } else {
        this.deleteModelo();
      }
    }
  },
  created() {
    if (this.$route.params.franquicia) {
      this.franquicia = this.serviceCommons.base64ToObject(
        this.$route.params.franquicia
      );
    }
    this.initValues();
    this.getModelos();
  }
};
</script>
